//============================================================================
// 533I2C_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// KeyPads.cpp : implementation file
//

#include "stdafx.h"
#include "533I2C_wintest.h"
#include "I2C.h"
#include "GPIO.h"
#include "KeyPads.h"
#include "TempsDlg.h"
#include "Packet_Debug.h"
#include "Live_Display.h"
#include "533I2C_WinTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define KP_UP     0x01
#define KP_ENTER  0x02
#define KP_CANCEL 0x04
#define KP_LEFT   0x08
#define KP_RIGHT  0x10
#define KP_DOWN   0x20

#define KP_UL     0x01 //(upper-left)
#define KP_UR     0x02 //(upper-right)
#define KP_LL     0x04 //(lower-left)
#define KP_LR     0x08 //(lower-right)

/////////////////////////////////////////////////////////////////////////////
// KeyPads dialog
KeyPads::KeyPads(CWnd* pParent /*=NULL*/)
  : CDialog(KeyPads::IDD, pParent)
  {
  //{{AFX_DATA_INIT(KeyPads)
  //}}AFX_DATA_INIT
  ASSERT(pParent != NULL);

  m_pParent = pParent;
  m_nID = KeyPads::IDD;
  }

BOOL KeyPads::OnInitDialog()
  {
  CDialog::OnInitDialog();

  m_enable_key_legends.SetCheck(0);
  m_key_legend_ul.SetCurSel(0);
  m_key_legend_ur.SetCurSel(0);
  m_key_legend_ll.SetCurSel(0);
  m_key_legend_lr.SetCurSel(0);
  m_key_legend_ul.EnableWindow(0);
  m_key_legend_ur.EnableWindow(0);
  m_key_legend_ll.EnableWindow(0);
  m_key_legend_lr.EnableWindow(0);

  return TRUE;
  }

void KeyPads::DoDataExchange(CDataExchange* pDX)
  {
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(KeyPads)
  DDX_Control(pDX, IDC_REPORT_RELEASE_UR, m_report_release_ur);
  DDX_Control(pDX, IDC_REPORT_RELEASE_UP, m_report_release_up);
  DDX_Control(pDX, IDC_REPORT_RELEASE_UL, m_report_release_ul);
  DDX_Control(pDX, IDC_REPORT_RELEASE_RIGHT, m_report_release_right);
  DDX_Control(pDX, IDC_REPORT_RELEASE_LR, m_report_release_lr);
  DDX_Control(pDX, IDC_REPORT_RELEASE_LL, m_report_release_ll);
  DDX_Control(pDX, IDC_REPORT_RELEASE_LEFT, m_report_release_left);
  DDX_Control(pDX, IDC_REPORT_RELEASE_ENTER, m_report_release_enter);
  DDX_Control(pDX, IDC_REPORT_RELEASE_DOWN, m_report_release_down);
  DDX_Control(pDX, IDC_REPORT_RELEASE_CANCEL, m_report_release_cancel);
  DDX_Control(pDX, IDC_REPORT_PRESS_UR, m_report_press_ur);
  DDX_Control(pDX, IDC_REPORT_PRESS_UP, m_report_press_up);
  DDX_Control(pDX, IDC_REPORT_PRESS_UL, m_report_press_ul);
  DDX_Control(pDX, IDC_REPORT_PRESS_RIGHT, m_report_press_right);
  DDX_Control(pDX, IDC_REPORT_PRESS_LR, m_report_press_lr);
  DDX_Control(pDX, IDC_REPORT_PRESS_LL, m_report_press_ll);
  DDX_Control(pDX, IDC_REPORT_PRESS_LEFT, m_report_press_left);
  DDX_Control(pDX, IDC_REPORT_PRESS_ENTER, m_report_press_enter);
  DDX_Control(pDX, IDC_REPORT_PRESS_DOWN, m_report_press_down);
  DDX_Control(pDX, IDC_REPORT_PRESS_CANCEL, m_report_press_cancel);
  DDX_Control(pDX, IDC_KEY_UR, m_key_ur);
  DDX_Control(pDX, IDC_KEY_UP, m_key_up);
  DDX_Control(pDX, IDC_KEY_UL, m_key_ul);
  DDX_Control(pDX, IDC_KEY_RIGHT, m_key_right);
  DDX_Control(pDX, IDC_KEY_POLL_UR, m_key_poll_ur);
  DDX_Control(pDX, IDC_KEY_POLL_UP, m_key_poll_up);
  DDX_Control(pDX, IDC_KEY_POLL_UL, m_key_poll_ul);
  DDX_Control(pDX, IDC_KEY_POLL_RIGHT, m_key_poll_right);
  DDX_Control(pDX, IDC_KEY_POLL_LR, m_key_poll_lr);
  DDX_Control(pDX, IDC_KEY_POLL_LL, m_key_poll_ll);
  DDX_Control(pDX, IDC_KEY_POLL_LEFT, m_key_poll_left);
  DDX_Control(pDX, IDC_KEY_POLL_ENTER, m_key_poll_enter);
  DDX_Control(pDX, IDC_KEY_POLL_DOWN, m_key_poll_down);
  DDX_Control(pDX, IDC_KEY_POLL_CANCEL, m_key_poll_cancel);
  DDX_Control(pDX, IDC_KEY_LR, m_key_lr);
  DDX_Control(pDX, IDC_KEY_LL, m_key_ll);
  DDX_Control(pDX, IDC_KEY_LEGEND_UR, m_key_legend_ur);
  DDX_Control(pDX, IDC_KEY_LEGEND_UL, m_key_legend_ul);
  DDX_Control(pDX, IDC_KEY_LEGEND_LR, m_key_legend_lr);
  DDX_Control(pDX, IDC_KEY_LEGEND_LL, m_key_legend_ll);
  DDX_Control(pDX, IDC_KEY_LEFT, m_key_left);
  DDX_Control(pDX, IDC_KEY_ENTER, m_key_enter);
  DDX_Control(pDX, IDC_KEY_DOWN, m_key_down);
  DDX_Control(pDX, IDC_KEY_CANCEL, m_key_cancel);
  DDX_Control(pDX, IDC_ENABLE_KEY_LEGENDS, m_enable_key_legends);
  //}}AFX_DATA_MAP
  }

//Allows both ON_WM_CLOSE and ON_BN_CLICKED(IDOK, ) to map to
//a single function with out breaking the resource editor,
#define OnDone OnClose

BEGIN_MESSAGE_MAP(KeyPads, CDialog)
  //{{AFX_MSG_MAP(KeyPads)
  ON_BN_CLICKED(IDC_ALL_REPORTS_OFF_6_3_1, OnAllReportsOff6_3_1)
  ON_BN_CLICKED(IDC_ALL_REPORTS_ON_6_3_1, OnAllReportsOn6_3_1)
  ON_BN_CLICKED(IDC_POLL_KEYS_NOW_6_3_1, OnPollKeysNow6_3_1)
  ON_BN_CLICKED(IDC_REPORT_PRESS_LL, OnReportPressClick_6_3_1)
  ON_BN_CLICKED(IDC_REPORT_PRESS_LR, OnReportPressClick_6_3_1)
  ON_BN_CLICKED(IDC_REPORT_PRESS_UL, OnReportPressClick_6_3_1)
  ON_BN_CLICKED(IDC_REPORT_PRESS_UR, OnReportPressClick_6_3_1)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_LL, OnReportPressClick_6_3_1)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_LR, OnReportPressClick_6_3_1)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_UL, OnReportPressClick_6_3_1)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_UR, OnReportPressClick_6_3_1)
  ON_BN_CLICKED(IDC_ENABLE_KEY_LEGENDS, OnEnableKeyLegends)
  ON_CBN_CLOSEUP(IDC_KEY_LEGEND_LL, OnCloseupKeyLegendLl)
  ON_CBN_CLOSEUP(IDC_KEY_LEGEND_LR, OnCloseupKeyLegendLr)
  ON_CBN_CLOSEUP(IDC_KEY_LEGEND_UL, OnCloseupKeyLegendUl)
  ON_CBN_CLOSEUP(IDC_KEY_LEGEND_UR, OnCloseupKeyLegendUr)
  ON_BN_CLICKED(IDC_ALL_REPORTS_OFF_6_3_3, OnAllReportsOff6_3_3)
  ON_BN_CLICKED(IDC_ALL_REPORTS_ON_6_3_3, OnAllReportsOn6_3_3)
  ON_BN_CLICKED(IDC_GET_REPORTS_6_3_3, OnGetReports6_3_3)
  ON_BN_CLICKED(IDC_POLL_KEYS_NOW_6_3_3, OnPollKeysNow6_3_3)
  ON_BN_CLICKED(IDC_REPORT_PRESS_CANCEL, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_PRESS_DOWN, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_PRESS_ENTER, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_PRESS_LEFT, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_PRESS_RIGHT, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_PRESS_UP, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_CANCEL, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_DOWN, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_ENTER, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_LEFT, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_RIGHT, OnReportPressClick_6_3_3)
  ON_BN_CLICKED(IDC_REPORT_RELEASE_UP, OnReportPressClick_6_3_3)
  ON_WM_CANCELMODE()
  ON_WM_CAPTURECHANGED()
  ON_WM_CLOSE()
  ON_BN_CLICKED(IDOK, OnDone)
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// KeyPads message handlers
/////////////////////////////////////////////////////////////////////////////
BOOL KeyPads::Create()
  {
  return CDialog::Create(m_nID, m_pParent);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::PostNcDestroy()
  {
  delete this;
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnClose() 
  {
  ((CMy533I2C_WinTestDlg*)m_pParent)->KeyPads_Done();
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnReceivedKeyReport(COMMAND_PACKET *packet)
  {
  switch(packet->data[0])
    {
    case 1:  //KEY_UP_PRESS
      m_key_up.SetCheck(1);
      break;
    case 2:  //KEY_DOWN_PRESS
      m_key_down.SetCheck(1);
      break;
    case 3:  //KEY_LEFT_PRESS
      m_key_left.SetCheck(1);
      break;
    case 4:  //KEY_RIGHT_PRESS
      m_key_right.SetCheck(1);
      break;
    case 5:  //KEY_ENTER_PRESS
      m_key_enter.SetCheck(1);
      break;
    case 6:  //KEY_EXIT_PRESS
      m_key_cancel.SetCheck(1);
      break;
    case 7:  //KEY_UP_RELEASE
      m_key_up.SetCheck(0);
      break;
    case 8:  //KEY_DOWN_RELEASE
      m_key_down.SetCheck(0);
      break;
    case 9:  //KEY_LEFT_RELEASE
      m_key_left.SetCheck(0);
      break;
    case 10: //KEY_RIGHT_RELEASE
      m_key_right.SetCheck(0);
      break;
    case 11: //KEY_ENTER_RELEASE
      m_key_enter.SetCheck(0);
      break;
    case 12: //KEY_EXIT_RELEASE
      m_key_cancel.SetCheck(0);
      break;
    //631
    case 13: //KEY_UL_PRESS
      m_key_ul.SetCheck(1);
      break;
    case 14: //KEY_UR_PRESS
      m_key_ur.SetCheck(1);
      break;
    case 15: //KEY_LL_PRESS
      m_key_ll.SetCheck(1);
      break;
    case 16: //KEY_LR_PRESS
      m_key_lr.SetCheck(1);
      break;
    case 17: //KEY_UL_RELEASE
      m_key_ul.SetCheck(0);
      break;
    case 18: //KEY_UR_RELEASE
      m_key_ur.SetCheck(0);
      break;
    case 19: //KEY_LL_RELEASE
      m_key_ll.SetCheck(0);
      break;
    case 20: //KEY_LR_RELEASE
      m_key_lr.SetCheck(0);
      break;
    }
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnReceivedKeyPoll(COMMAND_PACKET *packet)
  {
  char
    string[20];

  sprintf(string,"%c%c%c",
          ((packet->data[1])&KP_UP)?'p':'-',
          ((packet->data[2])&KP_UP)?'r':'-',
          ((packet->data[0])&KP_UP)?'D':'U');
  m_key_poll_up.SetWindowText(string);

  sprintf(string,"%c%c%c",
          ((packet->data[1])&KP_ENTER)?'p':'-',
          ((packet->data[2])&KP_ENTER)?'r':'-',
          ((packet->data[0])&KP_ENTER)?'D':'U');
  m_key_poll_enter.SetWindowText(string);

  sprintf(string,"%c%c%c",
          ((packet->data[1])&KP_CANCEL)?'p':'-',
          ((packet->data[2])&KP_CANCEL)?'r':'-',
          ((packet->data[0])&KP_CANCEL)?'D':'U');
  m_key_poll_cancel.SetWindowText(string);

  sprintf(string,"%c%c%c",
          ((packet->data[1])&KP_RIGHT)?'p':'-',
          ((packet->data[2])&KP_RIGHT)?'r':'-',
          ((packet->data[0])&KP_RIGHT)?'D':'U');
  m_key_poll_right.SetWindowText(string);

  sprintf(string,"%c%c%c",
          ((packet->data[1])&KP_LEFT)?'p':'-',
          ((packet->data[2])&KP_LEFT)?'r':'-',
          ((packet->data[0])&KP_LEFT)?'D':'U');
  m_key_poll_left.SetWindowText(string);

  sprintf(string,"%c%c%c",
          ((packet->data[1])&KP_DOWN)?'p':'-',
          ((packet->data[2])&KP_DOWN)?'r':'-',
          ((packet->data[0])&KP_DOWN)?'D':'U');
  m_key_poll_down.SetWindowText(string);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnAllReportsOff6_3_1() 
  {
  m_report_press_ul.SetCheck(0);
  m_report_press_ur.SetCheck(0);
  m_report_press_ll.SetCheck(0);
  m_report_press_lr.SetCheck(0);

  m_report_release_ul.SetCheck(0);
  m_report_release_ur.SetCheck(0);
  m_report_release_ll.SetCheck(0);
  m_report_release_lr.SetCheck(0);

  COMMAND_PACKET
    packet;
  packet.command=23; //Set Key Reporting
  packet.data_length=2;
  packet.data[0]=0;  //press mask
  packet.data[1]=0;  //release mask
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnAllReportsOn6_3_1() 
  {
  m_report_press_ul.SetCheck(1);
  m_report_press_ur.SetCheck(1);
  m_report_press_ll.SetCheck(1);
  m_report_press_lr.SetCheck(1);

  m_report_release_ul.SetCheck(1);
  m_report_release_ur.SetCheck(1);
  m_report_release_ll.SetCheck(1);
  m_report_release_lr.SetCheck(1);

  COMMAND_PACKET
    packet;
  packet.command=23; //Set Key Reporting
  packet.data_length=2;
  packet.data[0]=0x0F;  //press mask
  packet.data[1]=0x0F;  //release mask
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnGetReports6_3_3() 
  {
  COMMAND_PACKET
    packet;
  packet.command=30;   //Read Reporting Status
  packet.data_length=0;
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnReceivedReportingStatus(COMMAND_PACKET *packet)
  {
  // data[5]=key_press_mask;
  m_report_press_up.SetCheck((packet->data[5]&KP_UP)?1:0);
  m_report_press_left.SetCheck((packet->data[5]&KP_LEFT)?1:0);
  m_report_press_enter.SetCheck((packet->data[5]&KP_ENTER)?1:0);
  m_report_press_right.SetCheck((packet->data[5]&KP_RIGHT)?1:0);
  m_report_press_cancel.SetCheck((packet->data[5]&KP_CANCEL)?1:0);
  m_report_press_down.SetCheck((packet->data[5]&KP_DOWN)?1:0);

  // data[6]=key_release_mask;
  m_report_release_up.SetCheck((packet->data[6]&KP_UP)?1:0);
  m_report_release_left.SetCheck((packet->data[6]&KP_LEFT)?1:0);
  m_report_release_enter.SetCheck((packet->data[6]&KP_ENTER)?1:0);
  m_report_release_right.SetCheck((packet->data[6]&KP_RIGHT)?1:0);
  m_report_release_cancel.SetCheck((packet->data[6]&KP_CANCEL)?1:0);
  m_report_release_down.SetCheck((packet->data[6]&KP_DOWN)?1:0);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnAllReportsOff6_3_3() 
  {
  m_report_press_up.SetCheck(0);
  m_report_press_left.SetCheck(0);
  m_report_press_enter.SetCheck(0);
  m_report_press_right.SetCheck(0);
  m_report_press_cancel.SetCheck(0);
  m_report_press_down.SetCheck(0);

  m_report_release_up.SetCheck(0);
  m_report_release_left.SetCheck(0);
  m_report_release_enter.SetCheck(0);
  m_report_release_right.SetCheck(0);
  m_report_release_cancel.SetCheck(0);
  m_report_release_down.SetCheck(0);

  COMMAND_PACKET
    packet;
  packet.command=23; //Set Key Reporting
  packet.data_length=2;
  packet.data[0]=0;  //press mask
  packet.data[1]=0;  //release mask
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnAllReportsOn6_3_3() 
  {
  m_report_press_up.SetCheck(1);
  m_report_press_left.SetCheck(1);
  m_report_press_enter.SetCheck(1);
  m_report_press_right.SetCheck(1);
  m_report_press_cancel.SetCheck(1);
  m_report_press_down.SetCheck(1);

  m_report_release_up.SetCheck(1);
  m_report_release_left.SetCheck(1);
  m_report_release_enter.SetCheck(1);
  m_report_release_right.SetCheck(1);
  m_report_release_cancel.SetCheck(1);
  m_report_release_down.SetCheck(1);

  COMMAND_PACKET
    packet;
  packet.command=23; //Set Key Reporting
  packet.data_length=2;
  packet.data[0]=0x3F;  //press mask
  packet.data[1]=0x3F;  //release mask
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnPollKeysNow6_3_1() 
  {
  COMMAND_PACKET
    packet;
  packet.command=24;   //Read Keypad, Polled Mode
  packet.data_length=0;
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnPollKeysNow6_3_3() 
  {
  OnPollKeysNow6_3_1();
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::UpdateKeyLegends(void) 
  {
  COMMAND_PACKET
    packet;
  packet.command=32;
  if(m_enable_key_legends.GetCheck())
    {
    packet.data[0]=1;
    packet.data[1]=m_key_legend_ul.GetCurSel();
    packet.data[2]=m_key_legend_ur.GetCurSel();
    packet.data[3]=m_key_legend_ll.GetCurSel();
    packet.data[4]=m_key_legend_lr.GetCurSel();
    packet.data_length=5;
    }
  else
    {
    packet.data[0]=0;
    packet.data_length=1;
    }
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnEnableKeyLegends() 
  {
  if(m_enable_key_legends.GetCheck())
    {
     m_key_legend_ul.EnableWindow(1);
     m_key_legend_ur.EnableWindow(1);
     m_key_legend_ll.EnableWindow(1);
     m_key_legend_lr.EnableWindow(1);
    }
  else
    {
     m_key_legend_ul.EnableWindow(0);
     m_key_legend_ur.EnableWindow(0);
     m_key_legend_ll.EnableWindow(0);
     m_key_legend_lr.EnableWindow(0);
    }
  UpdateKeyLegends();
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnCloseupKeyLegendLl() 
  {
  UpdateKeyLegends();
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnCloseupKeyLegendLr() 
  {
  UpdateKeyLegends();
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnCloseupKeyLegendUl() 
  {
  UpdateKeyLegends();
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnCloseupKeyLegendUr() 
  {
  UpdateKeyLegends();
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnReportPressClick_6_3_1() 
  {
  COMMAND_PACKET
    packet;
  packet.command=23; //Set Key Reporting
  packet.data_length=2;
  packet.data[0]=  //press mask
    (m_report_press_ul.GetCheck()?KP_UL:0)|
    (m_report_press_ur.GetCheck()?KP_UR:0)|
    (m_report_press_ll.GetCheck()?KP_LL:0)|
    (m_report_press_lr.GetCheck()?KP_LR:0);
  packet.data[1]=  //release mask
    (m_report_release_ul.GetCheck()?KP_UL:0)|
    (m_report_release_ur.GetCheck()?KP_UR:0)|
    (m_report_release_ll.GetCheck()?KP_LL:0)|
    (m_report_release_lr.GetCheck()?KP_LR:0);
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
void KeyPads::OnReportPressClick_6_3_3() 
  {
  COMMAND_PACKET
    packet;
  packet.command=23; //Set Key Reporting
  packet.data_length=2;
  packet.data[0]=  //press mask
    (m_report_press_up.GetCheck()?KP_UP:0)|
    (m_report_press_left.GetCheck()?KP_LEFT:0)|
    (m_report_press_enter.GetCheck()?KP_ENTER:0)|
    (m_report_press_right.GetCheck()?KP_RIGHT:0)|
    (m_report_press_cancel.GetCheck()?KP_CANCEL:0)|
    (m_report_press_down.GetCheck()?KP_DOWN:0);
  packet.data[1]=  //release mask
    (m_report_release_up.GetCheck()?KP_UP:0)|
    (m_report_release_left.GetCheck()?KP_LEFT:0)|
    (m_report_release_enter.GetCheck()?KP_ENTER:0)|
    (m_report_release_right.GetCheck()?KP_RIGHT:0)|
    (m_report_release_cancel.GetCheck()?KP_CANCEL:0)|
    (m_report_release_down.GetCheck()?KP_DOWN:0);
  //Send the packet to the module
  ((CMy533I2C_WinTestDlg*)m_pParent)->QueuePacket(&packet);
  }
/////////////////////////////////////////////////////////////////////////////
