//============================================================================
// 533I2C_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
// Live_Display.cpp : implementation file
//

#include "stdafx.h"
#include "533I2C_WinTest.h"
#include "I2C.h"
#include "GPIO.h"
#include "KeyPads.h"
#include "TempsDlg.h"
#include "Packet_Debug.h"
#include "Live_Display.h"
#include "533I2C_WinTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Live_Display dialog
Live_Display::Live_Display(CWnd* pParent /*=NULL*/)
  : CDialog(Live_Display::IDD, pParent)
  {
  //{{AFX_DATA_INIT(Live_Display)
    // NOTE: the ClassWizard will add member initialization here
  //}}AFX_DATA_INIT
  ASSERT(pParent != NULL);

  m_pParent = pParent;
  m_nID = Live_Display::IDD;
  }

BOOL Live_Display::OnInitDialog()
  {
  CDialog::OnInitDialog();

  //Get arrays of the dialog objects initialized so we can use loops to access
  //the objects.
  Types[0]=&m_Type_Slot_0;
  Types[1]=&m_Type_Slot_1;
  Types[2]=&m_Type_Slot_2;
  Types[3]=&m_Type_Slot_3;
  Types[4]=&m_Type_Slot_4;
  Types[5]=&m_Type_Slot_5;
  Types[6]=&m_Type_Slot_6;
  Types[7]=&m_Type_Slot_7;

  Sensors[0]=&m_Sensor_Slot_0;
  Sensors[1]=&m_Sensor_Slot_1;
  Sensors[2]=&m_Sensor_Slot_2;
  Sensors[3]=&m_Sensor_Slot_3;
  Sensors[4]=&m_Sensor_Slot_4;
  Sensors[5]=&m_Sensor_Slot_5;
  Sensors[6]=&m_Sensor_Slot_6;
  Sensors[7]=&m_Sensor_Slot_7;

  Digits[0]=&m_Digits_Slot_0;
  Digits[1]=&m_Digits_Slot_1;
  Digits[2]=&m_Digits_Slot_2;
  Digits[3]=&m_Digits_Slot_3;
  Digits[4]=&m_Digits_Slot_4;
  Digits[5]=&m_Digits_Slot_5;
  Digits[6]=&m_Digits_Slot_6;
  Digits[7]=&m_Digits_Slot_7;

  Cols[0]=&m_Col_Slot_0;
  Cols[1]=&m_Col_Slot_1;
  Cols[2]=&m_Col_Slot_2;
  Cols[3]=&m_Col_Slot_3;
  Cols[4]=&m_Col_Slot_4;
  Cols[5]=&m_Col_Slot_5;
  Cols[6]=&m_Col_Slot_6;
  Cols[7]=&m_Col_Slot_7;

  Rows[0]=&m_Row_Slot_0;
  Rows[1]=&m_Row_Slot_1;
  Rows[2]=&m_Row_Slot_2;
  Rows[3]=&m_Row_Slot_3;
  Rows[4]=&m_Row_Slot_4;
  Rows[5]=&m_Row_Slot_5;
  Rows[6]=&m_Row_Slot_6;
  Rows[7]=&m_Row_Slot_7;

  Units[0]=&m_Units_Slot_0;
  Units[1]=&m_Units_Slot_1;
  Units[2]=&m_Units_Slot_2;
  Units[3]=&m_Units_Slot_3;
  Units[4]=&m_Units_Slot_4;
  Units[5]=&m_Units_Slot_5;
  Units[6]=&m_Units_Slot_6;
  Units[7]=&m_Units_Slot_7;

  //Validate the data
  Validate_Parent_Data();

  //Enable/Disable the selections on the dialog
  Enable_Disable_Dialog_Elements();

  return TRUE;
  } 


void Live_Display::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(Live_Display)
  DDX_Control(pDX, IDC_Type_Slot_0, m_Type_Slot_0);
  DDX_Control(pDX, IDC_Type_Slot_1, m_Type_Slot_1);
  DDX_Control(pDX, IDC_Type_Slot_2, m_Type_Slot_2);
  DDX_Control(pDX, IDC_Type_Slot_3, m_Type_Slot_3);
  DDX_Control(pDX, IDC_Type_Slot_4, m_Type_Slot_4);
  DDX_Control(pDX, IDC_Type_Slot_5, m_Type_Slot_5);
  DDX_Control(pDX, IDC_Type_Slot_6, m_Type_Slot_6);
  DDX_Control(pDX, IDC_Type_Slot_7, m_Type_Slot_7);

  DDX_Control(pDX, IDC_Sensor_Slot_0, m_Sensor_Slot_0);
  DDX_Control(pDX, IDC_Sensor_Slot_1, m_Sensor_Slot_1);
  DDX_Control(pDX, IDC_Sensor_Slot_2, m_Sensor_Slot_2);
  DDX_Control(pDX, IDC_Sensor_Slot_3, m_Sensor_Slot_3);
  DDX_Control(pDX, IDC_Sensor_Slot_4, m_Sensor_Slot_4);
  DDX_Control(pDX, IDC_Sensor_Slot_5, m_Sensor_Slot_5);
  DDX_Control(pDX, IDC_Sensor_Slot_6, m_Sensor_Slot_6);
  DDX_Control(pDX, IDC_Sensor_Slot_7, m_Sensor_Slot_7);

  DDX_Control(pDX, IDC_Digits_Slot_0, m_Digits_Slot_0);
  DDX_Control(pDX, IDC_Digits_Slot_1, m_Digits_Slot_1);
  DDX_Control(pDX, IDC_Digits_Slot_2, m_Digits_Slot_2);
  DDX_Control(pDX, IDC_Digits_Slot_3, m_Digits_Slot_3);
  DDX_Control(pDX, IDC_Digits_Slot_4, m_Digits_Slot_4);
  DDX_Control(pDX, IDC_Digits_Slot_5, m_Digits_Slot_5);
  DDX_Control(pDX, IDC_Digits_Slot_6, m_Digits_Slot_6);
  DDX_Control(pDX, IDC_Digits_Slot_7, m_Digits_Slot_7);

  DDX_Control(pDX, IDC_Col_Slot_0, m_Col_Slot_0);
  DDX_Control(pDX, IDC_Col_Slot_1, m_Col_Slot_1);
  DDX_Control(pDX, IDC_Col_Slot_2, m_Col_Slot_2);
  DDX_Control(pDX, IDC_Col_Slot_3, m_Col_Slot_3);
  DDX_Control(pDX, IDC_Col_Slot_4, m_Col_Slot_4);
  DDX_Control(pDX, IDC_Col_Slot_5, m_Col_Slot_5);
  DDX_Control(pDX, IDC_Col_Slot_6, m_Col_Slot_6);
  DDX_Control(pDX, IDC_Col_Slot_7, m_Col_Slot_7);

  DDX_Control(pDX, IDC_Row_Slot_0, m_Row_Slot_0);
  DDX_Control(pDX, IDC_Row_Slot_1, m_Row_Slot_1);
  DDX_Control(pDX, IDC_Row_Slot_2, m_Row_Slot_2);
  DDX_Control(pDX, IDC_Row_Slot_3, m_Row_Slot_3);
  DDX_Control(pDX, IDC_Row_Slot_4, m_Row_Slot_4);
  DDX_Control(pDX, IDC_Row_Slot_5, m_Row_Slot_5);
  DDX_Control(pDX, IDC_Row_Slot_6, m_Row_Slot_6);
  DDX_Control(pDX, IDC_Row_Slot_7, m_Row_Slot_7);

  DDX_Control(pDX, IDC_Units_Slot_0, m_Units_Slot_0);
  DDX_Control(pDX, IDC_Units_Slot_1, m_Units_Slot_1);
  DDX_Control(pDX, IDC_Units_Slot_2, m_Units_Slot_2);
  DDX_Control(pDX, IDC_Units_Slot_3, m_Units_Slot_3);
  DDX_Control(pDX, IDC_Units_Slot_4, m_Units_Slot_4);
  DDX_Control(pDX, IDC_Units_Slot_5, m_Units_Slot_5);
  DDX_Control(pDX, IDC_Units_Slot_6, m_Units_Slot_6);
  DDX_Control(pDX, IDC_Units_Slot_7, m_Units_Slot_7);

  //}}AFX_DATA_MAP
}

//Allows both ON_WM_CLOSE and ON_BN_CLICKED(IDCANCEL, ) to map to
//a single function with out breaking the resource editor,
#define OnDone OnClose

BEGIN_MESSAGE_MAP(Live_Display, CDialog)
  //{{AFX_MSG_MAP(Live_Display)
  ON_CBN_CLOSEUP(IDC_Col_Slot_0, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Col_Slot_1, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Col_Slot_2, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Col_Slot_3, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Col_Slot_4, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Col_Slot_5, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Col_Slot_6, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Col_Slot_7, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Digits_Slot_0, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Digits_Slot_1, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Digits_Slot_2, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Digits_Slot_3, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Digits_Slot_4, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Digits_Slot_5, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Digits_Slot_6, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Digits_Slot_7, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Row_Slot_0, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Row_Slot_1, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Row_Slot_2, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Row_Slot_3, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Row_Slot_4, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Row_Slot_5, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Row_Slot_6, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Row_Slot_7, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Sensor_Slot_0, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Sensor_Slot_1, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Sensor_Slot_2, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Sensor_Slot_3, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Sensor_Slot_4, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Sensor_Slot_5, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Sensor_Slot_6, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Sensor_Slot_7, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Type_Slot_0, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Type_Slot_1, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Type_Slot_2, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Type_Slot_3, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Type_Slot_4, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Type_Slot_5, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Type_Slot_6, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Type_Slot_7, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Units_Slot_0, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Units_Slot_1, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Units_Slot_2, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Units_Slot_3, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Units_Slot_4, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Units_Slot_5, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Units_Slot_6, OnEditChange)
  ON_CBN_CLOSEUP(IDC_Units_Slot_7, OnEditChange)
  ON_BN_CLICKED(ID_SEND_TO_DISPLAY, OnSendToDisplay)
  ON_BN_CLICKED(IDCANCEL, OnDone)
  ON_WM_CLOSE()
  //}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
BOOL Live_Display::Create()
  {
  return CDialog::Create(m_nID, m_pParent);
  }
/////////////////////////////////////////////////////////////////////////////
void Live_Display::PostNcDestroy()
  {
  delete this;
  }
/////////////////////////////////////////////////////////////////////////////
void Live_Display::OnClose() 
  {
  ((CMy533I2C_WinTestDlg*)m_pParent)->Live_Display_Done();
  }
/////////////////////////////////////////////////////////////////////////////
//Pointers to our parent's data structure array
#define TYPE   (((CMy533I2C_WinTestDlg*)m_pParent)->live[slot].type)
#define INDEX  (((CMy533I2C_WinTestDlg*)m_pParent)->live[slot].index)
#define DIGITS (((CMy533I2C_WinTestDlg*)m_pParent)->live[slot].digits)
#define COLUMN (((CMy533I2C_WinTestDlg*)m_pParent)->live[slot].column)
#define ROW    (((CMy533I2C_WinTestDlg*)m_pParent)->live[slot].row)
#define UNITS  (((CMy533I2C_WinTestDlg*)m_pParent)->live[slot].units)

void Live_Display::Validate_Parent_Data(void)
  {
  //This function makes sure the parent's data is legal.
  int
    slot;
  for(slot=0;slot<=7;slot++)
    switch(TYPE)
      {
      case 0: //off
        //everything is valid if it is off.
        break;
      case 1: //tach
        if(3<INDEX)
          INDEX=0;
        if((DIGITS!=4)&&(DIGITS!=5))
          DIGITS=4;
        if(15<COLUMN)
          COLUMN=0;
        if(1<ROW)
          ROW=0;
        if((UNITS<1)||(32<UNITS))
          UNITS=2;
        break;
      case 2: //temp
        if(31<INDEX)
          INDEX=0;
        if((DIGITS!=3)&&(DIGITS!=5))
          DIGITS=3;
        if(15<COLUMN)
          COLUMN=0;
        if(1<ROW)
          ROW=0;
        if(1<UNITS)
          UNITS=0;
        break;
      default: //invalid type, turn it off
        TYPE=0; 
        break;
      }
  }
/////////////////////////////////////////////////////////////////////////////
void Live_Display::Enable_Disable_Dialog_Elements(void)
  {
  int
    sensor;
  char
    sensor_name[30];
  int
    col;
  char
    col_name[30];
  int
    slot;
  for(slot=0;slot<=7;slot++)
    {
    Types[slot]->SetCurSel(TYPE);
    //We know that the data is good. Just set all the window
    //elements correctly.
    //First re-enable (or disable) all the drop-downs, then
    //pre-select them from the parent's data
    switch(TYPE)
      {
      case 0: //off
        Sensors[slot]->ResetContent();
        Sensors[slot]->EnableWindow(0);
        Digits[slot]->ResetContent();
        Digits[slot]->EnableWindow(0);
        Cols[slot]->ResetContent();
        Cols[slot]->EnableWindow(0);
        Rows[slot]->ResetContent();
        Rows[slot]->EnableWindow(0);
        Units[slot]->ResetContent();
        Units[slot]->EnableWindow(0);
        break;
      case 1: //tach
        Sensors[slot]->ResetContent();
        break;
      case 2: //temp
        Sensors[slot]->ResetContent();
        for(sensor=1;sensor<=32;sensor++)
          {
          sprintf(sensor_name,"Temp %2d",sensor);
          Sensors[slot]->AddString(sensor_name);
          }
        Sensors[slot]->SetCurSel(INDEX);
        Sensors[slot]->EnableWindow(1);

        Digits[slot]->ResetContent();
        Digits[slot]->AddString("3");
        Digits[slot]->AddString("5");
        if(DIGITS==3)
          Digits[slot]->SetCurSel(0);
        else
          Digits[slot]->SetCurSel(1);
        Digits[slot]->EnableWindow(1);

        Cols[slot]->ResetContent();
        for(col=0;col<=15;col++)
          {
          sprintf(col_name,"%2d",col);
          Cols[slot]->AddString(col_name);
          }
        Cols[slot]->SetCurSel(COLUMN);
        Cols[slot]->EnableWindow(1);

        Rows[slot]->ResetContent();
        Rows[slot]->AddString("0");
        Rows[slot]->AddString("1");
        Rows[slot]->SetCurSel(ROW);
        Rows[slot]->EnableWindow(1);

        Units[slot]->ResetContent();
        Units[slot]->AddString("C");
        Units[slot]->AddString("F");
        Units[slot]->SetCurSel(UNITS);
        Units[slot]->EnableWindow(1);
        break;
      }
    }      
  }
/////////////////////////////////////////////////////////////////////////////
// Live_Display message handlers
void Live_Display::OnEditChange(void) 
  {
  int
    slot;
  for(slot=0;slot<=7;slot++)
    {
    //Save the changes to our parent's structure.
    TYPE=Types[slot]->GetCurSel();
     // This is to make temp where tach was
    if(TYPE==1)
      TYPE=2;
    switch(TYPE)
      {
      case 0: //off
        //Don't store anything else
        break;
      case 1: //tach
        INDEX=Sensors[slot]->GetCurSel();
        DIGITS=Digits[slot]->GetCurSel()+4;
        COLUMN=Cols[slot]->GetCurSel();
        ROW=Rows[slot]->GetCurSel();
        UNITS=Units[slot]->GetCurSel()+1;
        break;
      case 2: //temp
        INDEX=Sensors[slot]->GetCurSel();
        if(Digits[slot]->GetCurSel())
          DIGITS=5;
        else
          DIGITS=3;
        COLUMN=Cols[slot]->GetCurSel();
        ROW=Rows[slot]->GetCurSel();
        UNITS=Units[slot]->GetCurSel();
        break;
      }
    }
  Validate_Parent_Data();
  Enable_Disable_Dialog_Elements();
  }
/////////////////////////////////////////////////////////////////////////////
void Live_Display::OnSendToDisplay() 
  {
  ((CMy533I2C_WinTestDlg*)m_pParent)->Send_Live_Data_To_Display();
  }
/////////////////////////////////////////////////////////////////////////////
